/* gnome-plugin.c generated by valac 0.32.1, the Vala compiler
 * generated from gnome-plugin.vala, do not modify */

/*
 * Copyright (c) 2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <libpeas/peas.h>
#include "gnome-pomodoro.h"
#include <gio/gio.h>
#include "libgnome-desktop/gnome-bg-crossfade.h"
#include "libgnome-desktop/gnome-bg-slide-show.h"
#include "libgnome-desktop/gnome-bg.h"
#include "libgnome-desktop/gnome-desktop-thumbnail.h"
#include "libgnome-desktop/gnome-idle-monitor.h"
#include "libgnome-desktop/gnome-languages.h"
#include "libgnome-desktop/gnome-pnp-ids.h"
#include "libgnome-desktop/gnome-rr-config.h"
#include "libgnome-desktop/gnome-rr.h"
#include "libgnome-desktop/gnome-wall-clock.h"
#include "libgnome-desktop/gnome-xkb-info.h"
#include <config.h>


#define GNOME_PLUGIN_TYPE_APPLICATION_EXTENSION (gnome_plugin_application_extension_get_type ())
#define GNOME_PLUGIN_APPLICATION_EXTENSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOME_PLUGIN_TYPE_APPLICATION_EXTENSION, GnomePluginApplicationExtension))
#define GNOME_PLUGIN_APPLICATION_EXTENSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOME_PLUGIN_TYPE_APPLICATION_EXTENSION, GnomePluginApplicationExtensionClass))
#define GNOME_PLUGIN_IS_APPLICATION_EXTENSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOME_PLUGIN_TYPE_APPLICATION_EXTENSION))
#define GNOME_PLUGIN_IS_APPLICATION_EXTENSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOME_PLUGIN_TYPE_APPLICATION_EXTENSION))
#define GNOME_PLUGIN_APPLICATION_EXTENSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOME_PLUGIN_TYPE_APPLICATION_EXTENSION, GnomePluginApplicationExtensionClass))

typedef struct _GnomePluginApplicationExtension GnomePluginApplicationExtension;
typedef struct _GnomePluginApplicationExtensionClass GnomePluginApplicationExtensionClass;
typedef struct _GnomePluginApplicationExtensionPrivate GnomePluginApplicationExtensionPrivate;

#define GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION (gnome_plugin_gnome_shell_extension_get_type ())
#define GNOME_PLUGIN_GNOME_SHELL_EXTENSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION, GnomePluginGnomeShellExtension))
#define GNOME_PLUGIN_GNOME_SHELL_EXTENSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION, GnomePluginGnomeShellExtensionClass))
#define GNOME_PLUGIN_IS_GNOME_SHELL_EXTENSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION))
#define GNOME_PLUGIN_IS_GNOME_SHELL_EXTENSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION))
#define GNOME_PLUGIN_GNOME_SHELL_EXTENSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION, GnomePluginGnomeShellExtensionClass))

typedef struct _GnomePluginGnomeShellExtension GnomePluginGnomeShellExtension;
typedef struct _GnomePluginGnomeShellExtensionClass GnomePluginGnomeShellExtensionClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _GnomePluginApplicationExtension {
	PeasExtensionBase parent_instance;
	GnomePluginApplicationExtensionPrivate * priv;
};

struct _GnomePluginApplicationExtensionClass {
	PeasExtensionBaseClass parent_class;
};

struct _GnomePluginApplicationExtensionPrivate {
	PomodoroTimer* timer;
	GSettings* settings;
	PomodoroCapabilityGroup* capabilities;
	PomodoroCapabilityGroup* shell_capabilities;
	GnomePluginGnomeShellExtension* shell_extension;
	GnomeIdleMonitor* idle_monitor;
	guint become_active_id;
	gboolean configured;
	gdouble last_activity_time;
};


static gpointer gnome_plugin_application_extension_parent_class = NULL;
static PomodoroApplicationExtensionIface* gnome_plugin_application_extension_pomodoro_application_extension_parent_iface = NULL;
static GType gnome_plugin_application_extension_type_id = 0;

#define GNOME_PLUGIN_IDLE_MONITOR_MIN_IDLE_TIME 0.5
#define GNOME_PLUGIN_CURRENT_DESKTOP_VARIABLE "XDG_CURRENT_DESKTOP"
GType gnome_plugin_application_extension_get_type (void) G_GNUC_CONST;
GType gnome_plugin_application_extension_register_type (GTypeModule * module);
GType gnome_plugin_gnome_shell_extension_get_type (void) G_GNUC_CONST;
GType gnome_plugin_gnome_shell_extension_register_type (GTypeModule * module);
#define GNOME_PLUGIN_APPLICATION_EXTENSION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GNOME_PLUGIN_TYPE_APPLICATION_EXTENSION, GnomePluginApplicationExtensionPrivate))
enum  {
	GNOME_PLUGIN_APPLICATION_EXTENSION_DUMMY_PROPERTY
};
static void gnome_plugin_application_extension_on_timer_state_changed (GnomePluginApplicationExtension* self, PomodoroTimerState* state, PomodoroTimerState* previous_state);
static void _gnome_plugin_application_extension_on_timer_state_changed_pomodoro_timer_state_changed (PomodoroTimer* _sender, PomodoroTimerState* state, PomodoroTimerState* previous_state, gpointer self);
static void gnome_plugin_application_extension_setup (GnomePluginApplicationExtension* self);
void gnome_plugin_gnome_shell_extension_enable (GnomePluginGnomeShellExtension* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
void gnome_plugin_gnome_shell_extension_enable_finish (GnomePluginGnomeShellExtension* self, GAsyncResult* _res_);
static void ___lambda6_ (GnomePluginApplicationExtension* self, GObject* obj, GAsyncResult* res);
static void gnome_plugin_application_extension_on_shell_extension_enabled_notify (GnomePluginApplicationExtension* self);
static void _gnome_plugin_application_extension_on_shell_extension_enabled_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void ____lambda6__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
gboolean gnome_plugin_gnome_shell_extension_get_enabled (GnomePluginGnomeShellExtension* self);
static void gnome_plugin_application_extension_on_become_active (GnomePluginApplicationExtension* self, GnomeIdleMonitor* monitor, guint id);
static void _gnome_plugin_application_extension_on_become_active_gnome_idle_monitor_watch_func (GnomeIdleMonitor* monitor, guint id, gpointer self);
GnomePluginApplicationExtension* gnome_plugin_application_extension_new (void);
GnomePluginApplicationExtension* gnome_plugin_application_extension_construct (GType object_type);
static GObject * gnome_plugin_application_extension_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
GnomePluginGnomeShellExtension* gnome_plugin_gnome_shell_extension_new (const gchar* uuid);
GnomePluginGnomeShellExtension* gnome_plugin_gnome_shell_extension_construct (GType object_type, const gchar* uuid);
static void gnome_plugin_application_extension_finalize (GObject* obj);
void peas_register_types (GTypeModule* module);

static const gchar* GNOME_PLUGIN_APPLICATION_EXTENSION_SHELL_CAPABILITIES[5] = {"notifications", "indicator", "accelerator", "reminders", "hide-system-notifications"};

static void _gnome_plugin_application_extension_on_timer_state_changed_pomodoro_timer_state_changed (PomodoroTimer* _sender, PomodoroTimerState* state, PomodoroTimerState* previous_state, gpointer self) {
	gnome_plugin_application_extension_on_timer_state_changed ((GnomePluginApplicationExtension*) self, state, previous_state);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _gnome_plugin_application_extension_on_shell_extension_enabled_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	gnome_plugin_application_extension_on_shell_extension_enabled_notify ((GnomePluginApplicationExtension*) self);
}


static void ___lambda6_ (GnomePluginApplicationExtension* self, GObject* obj, GAsyncResult* res) {
	GnomePluginGnomeShellExtension* _tmp0_ = NULL;
	GAsyncResult* _tmp1_ = NULL;
	GnomePluginGnomeShellExtension* _tmp2_ = NULL;
	g_return_if_fail (res != NULL);
	_tmp0_ = self->priv->shell_extension;
	_tmp1_ = res;
	gnome_plugin_gnome_shell_extension_enable_finish (_tmp0_, _tmp1_);
	_tmp2_ = self->priv->shell_extension;
	g_signal_connect_object ((GObject*) _tmp2_, "notify::enabled", (GCallback) _gnome_plugin_application_extension_on_shell_extension_enabled_notify_g_object_notify, self, 0);
	gnome_plugin_application_extension_on_shell_extension_enabled_notify (self);
}


static void ____lambda6__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
	___lambda6_ ((GnomePluginApplicationExtension*) self, source_object, res);
	g_object_unref (self);
}


static void gnome_plugin_application_extension_setup (GnomePluginApplicationExtension* self) {
	const gchar* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_getenv (GNOME_PLUGIN_CURRENT_DESKTOP_VARIABLE);
	if (g_strcmp0 (_tmp0_, "GNOME") == 0) {
		PomodoroApplication* application = NULL;
		PomodoroApplication* _tmp1_ = NULL;
		PomodoroApplication* _tmp2_ = NULL;
		PomodoroApplication* _tmp3_ = NULL;
		PomodoroCapabilityManager* _tmp4_ = NULL;
		PomodoroCapabilityGroup* _tmp5_ = NULL;
		PomodoroApplication* _tmp6_ = NULL;
		PomodoroCapabilityManager* _tmp7_ = NULL;
		PomodoroCapabilityGroup* _tmp8_ = NULL;
		GnomePluginGnomeShellExtension* _tmp9_ = NULL;
		_tmp1_ = pomodoro_application_get_default ();
		_tmp2_ = _g_object_ref0 (_tmp1_);
		application = _tmp2_;
		_tmp3_ = application;
		_tmp4_ = _tmp3_->capabilities;
		_tmp5_ = self->priv->capabilities;
		pomodoro_capability_manager_add_group (_tmp4_, _tmp5_, POMODORO_PRIORITY_HIGH);
		_tmp6_ = application;
		_tmp7_ = _tmp6_->capabilities;
		_tmp8_ = self->priv->shell_capabilities;
		pomodoro_capability_manager_add_group (_tmp7_, _tmp8_, POMODORO_PRIORITY_HIGH);
		_tmp9_ = self->priv->shell_extension;
		gnome_plugin_gnome_shell_extension_enable (_tmp9_, ____lambda6__gasync_ready_callback, g_object_ref (self));
		_g_object_unref0 (application);
	}
}


static void gnome_plugin_application_extension_on_shell_extension_enabled_notify (GnomePluginApplicationExtension* self) {
	PomodoroApplication* application = NULL;
	PomodoroApplication* _tmp0_ = NULL;
	PomodoroApplication* _tmp1_ = NULL;
	GnomePluginGnomeShellExtension* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = pomodoro_application_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	application = _tmp1_;
	_tmp2_ = self->priv->shell_extension;
	_tmp3_ = gnome_plugin_gnome_shell_extension_get_enabled (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		PomodoroApplication* _tmp5_ = NULL;
		PomodoroCapabilityManager* _tmp6_ = NULL;
		PomodoroCapabilityGroup* _tmp7_ = NULL;
		_tmp5_ = application;
		_tmp6_ = _tmp5_->capabilities;
		_tmp7_ = self->priv->shell_capabilities;
		pomodoro_capability_manager_add_group (_tmp6_, _tmp7_, POMODORO_PRIORITY_HIGH);
	} else {
		PomodoroApplication* _tmp8_ = NULL;
		PomodoroCapabilityManager* _tmp9_ = NULL;
		PomodoroCapabilityGroup* _tmp10_ = NULL;
		_tmp8_ = application;
		_tmp9_ = _tmp8_->capabilities;
		_tmp10_ = self->priv->shell_capabilities;
		pomodoro_capability_manager_remove_group (_tmp9_, _tmp10_);
	}
	_g_object_unref0 (application);
}


static void _gnome_plugin_application_extension_on_become_active_gnome_idle_monitor_watch_func (GnomeIdleMonitor* monitor, guint id, gpointer self) {
	gnome_plugin_application_extension_on_become_active ((GnomePluginApplicationExtension*) self, monitor, id);
}


static void gnome_plugin_application_extension_on_timer_state_changed (GnomePluginApplicationExtension* self, PomodoroTimerState* state, PomodoroTimerState* previous_state) {
	guint _tmp0_ = 0U;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	PomodoroTimerState* _tmp6_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (state != NULL);
	g_return_if_fail (previous_state != NULL);
	_tmp0_ = self->priv->become_active_id;
	if (_tmp0_ != ((guint) 0)) {
		GnomeIdleMonitor* _tmp1_ = NULL;
		guint _tmp2_ = 0U;
		_tmp1_ = self->priv->idle_monitor;
		_tmp2_ = self->priv->become_active_id;
		gnome_idle_monitor_remove_watch (_tmp1_, _tmp2_);
		self->priv->become_active_id = (guint) 0;
	}
	_tmp6_ = state;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, POMODORO_TYPE_POMODORO_STATE)) {
		PomodoroTimerState* _tmp7_ = NULL;
		_tmp7_ = previous_state;
		_tmp5_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, POMODORO_TYPE_BREAK_STATE);
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		PomodoroTimerState* _tmp8_ = NULL;
		gboolean _tmp9_ = FALSE;
		_tmp8_ = previous_state;
		_tmp9_ = pomodoro_timer_state_is_completed (_tmp8_);
		_tmp4_ = _tmp9_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		GSettings* _tmp10_ = NULL;
		gboolean _tmp11_ = FALSE;
		_tmp10_ = self->priv->settings;
		_tmp11_ = g_settings_get_boolean (_tmp10_, "pause-when-idle");
		_tmp3_ = _tmp11_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		GnomeIdleMonitor* _tmp12_ = NULL;
		guint _tmp13_ = 0U;
		PomodoroTimer* _tmp14_ = NULL;
		_tmp12_ = self->priv->idle_monitor;
		_tmp13_ = gnome_idle_monitor_add_user_active_watch (_tmp12_, _gnome_plugin_application_extension_on_become_active_gnome_idle_monitor_watch_func, g_object_ref (self), g_object_unref);
		self->priv->become_active_id = _tmp13_;
		_tmp14_ = self->priv->timer;
		pomodoro_timer_pause (_tmp14_);
	}
}


/**
         * on_become_active callback
         *
         * We want to detect user/human activity so it sparse events.
         */
static void gnome_plugin_application_extension_on_become_active (GnomePluginApplicationExtension* self, GnomeIdleMonitor* monitor, guint id) {
	gdouble timestamp = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp6_ = 0.0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (monitor != NULL);
	_tmp0_ = pomodoro_get_real_time ();
	timestamp = _tmp0_;
	_tmp1_ = timestamp;
	_tmp2_ = self->priv->last_activity_time;
	if ((_tmp1_ - _tmp2_) < GNOME_PLUGIN_IDLE_MONITOR_MIN_IDLE_TIME) {
		PomodoroTimer* _tmp3_ = NULL;
		self->priv->become_active_id = (guint) 0;
		_tmp3_ = self->priv->timer;
		pomodoro_timer_resume (_tmp3_);
	} else {
		GnomeIdleMonitor* _tmp4_ = NULL;
		guint _tmp5_ = 0U;
		_tmp4_ = self->priv->idle_monitor;
		_tmp5_ = gnome_idle_monitor_add_user_active_watch (_tmp4_, _gnome_plugin_application_extension_on_become_active_gnome_idle_monitor_watch_func, g_object_ref (self), g_object_unref);
		self->priv->become_active_id = _tmp5_;
	}
	_tmp6_ = timestamp;
	self->priv->last_activity_time = _tmp6_;
}


GnomePluginApplicationExtension* gnome_plugin_application_extension_construct (GType object_type) {
	GnomePluginApplicationExtension * self = NULL;
	self = (GnomePluginApplicationExtension*) g_object_new (object_type, NULL);
	return self;
}


GnomePluginApplicationExtension* gnome_plugin_application_extension_new (void) {
	return gnome_plugin_application_extension_construct (GNOME_PLUGIN_TYPE_APPLICATION_EXTENSION);
}


static GObject * gnome_plugin_application_extension_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	GnomePluginApplicationExtension * self;
	GSettings* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	GnomeIdleMonitor* _tmp2_ = NULL;
	GnomePluginGnomeShellExtension* _tmp3_ = NULL;
	PomodoroCapabilityGroup* _tmp4_ = NULL;
	PomodoroCapabilityGroup* _tmp5_ = NULL;
	PomodoroCapability* _tmp6_ = NULL;
	PomodoroCapability* _tmp7_ = NULL;
	PomodoroCapabilityGroup* _tmp8_ = NULL;
	PomodoroTimer* _tmp17_ = NULL;
	PomodoroTimer* _tmp18_ = NULL;
	PomodoroTimer* _tmp19_ = NULL;
	parent_class = G_OBJECT_CLASS (gnome_plugin_application_extension_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNOME_PLUGIN_TYPE_APPLICATION_EXTENSION, GnomePluginApplicationExtension);
	_tmp0_ = pomodoro_get_settings ();
	_tmp1_ = g_settings_get_child (_tmp0_, "preferences");
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp1_;
	_tmp2_ = gnome_idle_monitor_new ();
	_g_object_unref0 (self->priv->idle_monitor);
	self->priv->idle_monitor = _tmp2_;
	_tmp3_ = gnome_plugin_gnome_shell_extension_new (EXTENSION_UUID);
	_g_object_unref0 (self->priv->shell_extension);
	self->priv->shell_extension = _tmp3_;
	_tmp4_ = pomodoro_capability_group_new ("gnome");
	_g_object_unref0 (self->priv->capabilities);
	self->priv->capabilities = _tmp4_;
	_tmp5_ = self->priv->capabilities;
	_tmp6_ = pomodoro_capability_new ("idle-monitor", NULL, NULL, NULL, NULL);
	g_object_ref_sink (_tmp6_);
	_tmp7_ = _tmp6_;
	pomodoro_capability_group_add (_tmp5_, _tmp7_);
	_g_object_unref0 (_tmp7_);
	_tmp8_ = pomodoro_capability_group_new ("gnome-shell");
	_g_object_unref0 (self->priv->shell_capabilities);
	self->priv->shell_capabilities = _tmp8_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp9_ = FALSE;
			_tmp9_ = TRUE;
			while (TRUE) {
				gint _tmp11_ = 0;
				PomodoroCapabilityGroup* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				const gchar* _tmp14_ = NULL;
				PomodoroCapability* _tmp15_ = NULL;
				PomodoroCapability* _tmp16_ = NULL;
				if (!_tmp9_) {
					gint _tmp10_ = 0;
					_tmp10_ = i;
					i = _tmp10_ + 1;
				}
				_tmp9_ = FALSE;
				_tmp11_ = i;
				if (!(_tmp11_ < G_N_ELEMENTS (GNOME_PLUGIN_APPLICATION_EXTENSION_SHELL_CAPABILITIES))) {
					break;
				}
				_tmp12_ = self->priv->shell_capabilities;
				_tmp13_ = i;
				_tmp14_ = GNOME_PLUGIN_APPLICATION_EXTENSION_SHELL_CAPABILITIES[_tmp13_];
				_tmp15_ = pomodoro_capability_new (_tmp14_, NULL, NULL, NULL, NULL);
				g_object_ref_sink (_tmp15_);
				_tmp16_ = _tmp15_;
				pomodoro_capability_group_add (_tmp12_, _tmp16_);
				_g_object_unref0 (_tmp16_);
			}
		}
	}
	_tmp17_ = pomodoro_timer_get_default ();
	_tmp18_ = _g_object_ref0 (_tmp17_);
	_g_object_unref0 (self->priv->timer);
	self->priv->timer = _tmp18_;
	_tmp19_ = self->priv->timer;
	g_signal_connect_object (_tmp19_, "state-changed", (GCallback) _gnome_plugin_application_extension_on_timer_state_changed_pomodoro_timer_state_changed, self, G_CONNECT_AFTER);
	gnome_plugin_application_extension_setup (self);
	return obj;
}


static void gnome_plugin_application_extension_class_init (GnomePluginApplicationExtensionClass * klass) {
	gnome_plugin_application_extension_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GnomePluginApplicationExtensionPrivate));
	G_OBJECT_CLASS (klass)->constructor = gnome_plugin_application_extension_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnome_plugin_application_extension_finalize;
}


static void gnome_plugin_application_extension_pomodoro_application_extension_interface_init (PomodoroApplicationExtensionIface * iface) {
	gnome_plugin_application_extension_pomodoro_application_extension_parent_iface = g_type_interface_peek_parent (iface);
}


static void gnome_plugin_application_extension_instance_init (GnomePluginApplicationExtension * self) {
	self->priv = GNOME_PLUGIN_APPLICATION_EXTENSION_GET_PRIVATE (self);
	self->priv->become_active_id = (guint) 0;
	self->priv->configured = FALSE;
	self->priv->last_activity_time = 0.0;
}


static void gnome_plugin_application_extension_finalize (GObject* obj) {
	GnomePluginApplicationExtension * self;
	PomodoroTimer* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNOME_PLUGIN_TYPE_APPLICATION_EXTENSION, GnomePluginApplicationExtension);
	_tmp0_ = self->priv->timer;
	g_signal_parse_name ("state-changed", POMODORO_TYPE_TIMER, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _gnome_plugin_application_extension_on_timer_state_changed_pomodoro_timer_state_changed, self);
	_tmp2_ = self->priv->become_active_id;
	if (_tmp2_ != ((guint) 0)) {
		GnomeIdleMonitor* _tmp3_ = NULL;
		guint _tmp4_ = 0U;
		_tmp3_ = self->priv->idle_monitor;
		_tmp4_ = self->priv->become_active_id;
		gnome_idle_monitor_remove_watch (_tmp3_, _tmp4_);
		self->priv->become_active_id = (guint) 0;
	}
	_g_object_unref0 (self->priv->timer);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->capabilities);
	_g_object_unref0 (self->priv->shell_capabilities);
	_g_object_unref0 (self->priv->shell_extension);
	_g_object_unref0 (self->priv->idle_monitor);
	G_OBJECT_CLASS (gnome_plugin_application_extension_parent_class)->finalize (obj);
}


GType gnome_plugin_application_extension_get_type (void) {
	return gnome_plugin_application_extension_type_id;
}


GType gnome_plugin_application_extension_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (GnomePluginApplicationExtensionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnome_plugin_application_extension_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomePluginApplicationExtension), 0, (GInstanceInitFunc) gnome_plugin_application_extension_instance_init, NULL };
	static const GInterfaceInfo pomodoro_application_extension_info = { (GInterfaceInitFunc) gnome_plugin_application_extension_pomodoro_application_extension_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	gnome_plugin_application_extension_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "GnomePluginApplicationExtension", &g_define_type_info, 0);
	g_type_module_add_interface (module, gnome_plugin_application_extension_type_id, POMODORO_TYPE_APPLICATION_EXTENSION, &pomodoro_application_extension_info);
	return gnome_plugin_application_extension_type_id;
}


void peas_register_types (GTypeModule* module) {
	PeasObjectModule* object_module = NULL;
	GTypeModule* _tmp0_ = NULL;
	PeasObjectModule* _tmp1_ = NULL;
	g_return_if_fail (module != NULL);
	gnome_shell_register_type (module);
	gnome_shell_proxy_register_dynamic_type (module);
	gnome_shell_extensions_register_type (module);
	gnome_shell_extensions_proxy_register_dynamic_type (module);
	gnome_plugin_application_extension_register_type (module);
	gnome_plugin_gnome_shell_extension_register_type (module);
	_tmp0_ = module;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, peas_object_module_get_type ()) ? ((PeasObjectModule*) _tmp0_) : NULL);
	object_module = _tmp1_;
	peas_object_module_register_extension_type (object_module, POMODORO_TYPE_APPLICATION_EXTENSION, GNOME_PLUGIN_TYPE_APPLICATION_EXTENSION);
	_g_object_unref0 (object_module);
}



